import { NgModule } from '@angular/core';
import { RouterModule,Routes } from '@angular/router';
import { PostPageComponent } from './post-page/post-page.component'; // 导入 PostPage 组件
import { CommunityPage } from './community/community.page';
import { SharePageComponent } from './share-page/share-page.component';

export const routes: Routes = [
 
  {
    path: '',
    loadChildren: () => import('./tabs/tabs.routes').then((m) => m.routes),
  },
  {
    path: 'customization',
    loadComponent: () => import('./customization/customization.page').then( m => m.CustomizationPage)
  },
  {
    path: 'community',
    loadComponent: () => import('./community/community.page').then( m => m.CommunityPage)
  },
  {
    path: 'yiyun',
    loadComponent: () => import('./yiyun/yiyun.page').then( m => m.YiyunPage)
  },
  {
    path: 'store',
    loadComponent: () => import('./store/store.page').then( m => m.StorePage)
  },
  {
    path: 'me',
    loadComponent: () => import('./me/me.page').then( m => m.MePage)
  },
  {
    path: 'report',
    loadComponent: () => import('./report/report.component').then( m => m.ReportComponent)
  },
  {
    path: 'test',
    loadComponent: () => import('./test/test.component').then( m => m.TestComponent)
  },
  {
    path: 'tianqi',
    loadComponent: () => import('./tianqi/tianqi.component').then( m => m.TianqiComponent)
  },
  {
    path: 'kuai',
    loadComponent: () => import('./kuai/kuai.component').then( m => m.KuaiComponent)
  },
  {
    path: 'testPage',
    loadComponent: () =>import('./test-page/test-page.component').then((m) => m.TestPageComponent)
  }, 
  { path: '', redirectTo: 'community', pathMatch: 'full' },
  { path: 'community', component: CommunityPage },
  { path: 'post-page/:id', component: PostPageComponent }, // 动态详情页面的路由
  { path: 'share', component: SharePageComponent },
];



  @NgModule({
    imports: [RouterModule.forRoot(routes)],
    exports: [RouterModule]
  })
  export class AppRoutingModule { }