import { Component, OnInit } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { Router } from '@angular/router';

import { IonCardSubtitle, IonTextarea, ModalController, IonBackButton } from '@ionic/angular/standalone';
import { IonContent, IonHeader, IonTitle, IonToolbar, IonButton, IonLabel, IonItem, IonList, IonButtons, IonIcon, IonItemDivider, IonAvatar, IonThumbnail, IonItemOptions, IonItemOption, IonItemSliding, IonInput, IonCheckbox, IonRadio, IonToggle, IonRadioGroup, IonSearchbar, IonSegment, IonSegmentButton, IonDatetime, IonFooter, IonCardContent, IonCardTitle, IonCardHeader, IonCard, IonCol, IonRow, IonGrid, IonChip, IonImg } from '@ionic/angular/standalone';
import { EditTagComponent } from '../edit-tag/edit-tag.component';
import { FmodeChatCompletion, MarkdownPreviewModule } from 'fmode-ng';
import { DalleOptions, ImagineWork } from 'fmode-ng';
import { ChatPanelOptions, FmChatModalInput, FmodeChat, FmodeChatMessage, openChatPanelModal } from 'fmode-ng';
import { Icon } from 'ionicons/dist/types/components/icon/icon';
import { camera, trendingUpOutline, sparklesOutline, cloudyOutline, diceOutline } from 'ionicons/icons';
import { addIcons } from 'ionicons';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';
import { SwiperComponent } from '../swiper/swiper.component';
import { extactAndParseJsonFromString } from 'src/agent/agent.json';
import {  ActivatedRoute, Params } from '@angular/router';
import { RouterModule } from '@angular/router';
import { NavController } from '@ionic/angular';
@Component({
  selector: 'app-report',
  templateUrl: './report.component.html',
  styleUrls: ['./report.component.scss'],
  standalone: true,
  imports: [IonContent, IonHeader, IonTitle, IonToolbar, CommonModule, FormsModule, IonButton, IonInput, EditTagComponent, IonTextarea, IonItem, IonList, MarkdownPreviewModule, IonIcon, IonContent, IonHeader, IonTitle, IonToolbar, CommonModule, FormsModule, IonButton, IonLabel, IonLabel, IonList, IonItem, IonBackButton, IonButtons, IonIcon, IonItemDivider, IonAvatar, IonThumbnail, IonItemOptions, IonItemSliding, IonItemOption, IonItemOptions, IonInput, IonCheckbox, IonRadio, IonToggle, IonRadioGroup, IonSearchbar, IonSegment, IonSegmentButton, IonDatetime, IonFooter, IonCardContent, IonCardTitle, IonCardHeader, IonCard, IonCol, IonRow, IonGrid, IonChip, IonImg, IonCardSubtitle, SwiperComponent]
})

export class ReportComponent  implements OnInit {
  public JSONKeys:string[]=[]
  public JSONobject: { [key: string]: string }={}
  public JSONKeys2:string[]=[]
  public JSONobject2: { [key: string]: string }={
    "goal": "婚礼",
    "style": "修身燕尾服",
    "color": "黑色",
    "feature": "",
    "ACC": "领带",
    "rim": "纽扣",
    "period": "7天",
    "clothing": "燕尾服+XXL",
    "trousers": "裤子+XXL",
    "shoe": "鞋子+42码",
    "after": "清洗",
    "texture": "丝绸",
    "remark": "",
    "detail": `根据用户的需求，我将详细描述这套定制服装的细节：

### 服装细节描述

#### 1. 颜色
- **主色调**：经典黑色，适合婚礼等正式场合，展现出优雅与庄重。

#### 2. 西装设计
- **外套**：
  - **款式**：经典单排扣设计，简洁大方，展现出传统的绅士风范。
  - **口袋**：前胸口袋设计，配以精致的口袋巾，口袋巾可以选择与领带对比色相呼应，增加整体的层次感。
  - **领口**：翻领设计，边缘精细缝制，增加服装的立体感与层次感。
  - **肩部**：根据用户需求，肩部设计略宽，确保舒适度与活动自如。

- **裤子**：
  - **款式**：修身版型，提升整体线条感，展现出干练的形象。
  - **长度**：裤脚设计为微喇形，适合搭配经典皮鞋，增强时尚感。

#### 3. 领带
- **颜色与材质**：选择对比色的领带，如红色、酒红色或深蓝色，采用丝绸或优质涤纶材质，增加光泽感，突出黑色西装的经典气质。
- **设计**：领带设计为简洁的斜纹或纯色，避免过于复杂的图案，以保持整体的优雅。

#### 4. 鞋子
- **款式**：推荐经典皮鞋，黑色或深棕色，搭配西装，保持风格的统一。
- **设计**：选择光面或微光面皮鞋，鞋型应为尖头设计，增强正式感。

#### 5. 配件
- **袖扣**：可以选择金属材质的简约袖扣，增加精致感，颜色可与领带相呼应。
- **领带夹**：推荐使用与袖扣相配的领带夹，简约而不失优雅，确保领带整齐。

### 尺码与合身
- **尺码**：根据用户提供的身高和体重，建议选择XXL尺码，确保合身，特别是在肩宽和胸围方面。
- **定制服务**：在定制过程中，提供试穿服务，确保最终成品的合身与舒适。

### 时间与售后
- **生产周期**：承诺在7天内完成定制，确保用户在婚礼前能够穿上这套西装。
- **售后服务**：提供7天内无理由退换的服务，确保用户在购买后的满意度。

### 总结
这套经典黑色西装结合了优雅的设计、舒适的合身和细致的配件，完美适应婚礼这一特殊场合，同时满足用户的个性化需求。`
}

  constructor(public activeRoute: ActivatedRoute, public nav:NavController,private router: Router) {
    
   }


  ngOnInit() {
    const navigation = this.router.getCurrentNavigation();
    if (navigation && navigation.extras && navigation.extras.state) {
      const state = navigation.extras.state;
      console.log(state['myObject']); // 访问传递的对象数据
      this.JSONobject=state['myObject']
      this.JSONKeys= Object.keys(this.JSONobject) 

      
    }
  }
  back(){
    this.nav.navigateRoot(['/tabs/customization'],{
      
    });
  }

}
