import { ImagineWork } from 'fmode-ng';
import { Component, OnInit } from '@angular/core';
import { IonContent, IonHeader, IonTitle, IonToolbar, IonButton, IonLabel, IonItem, IonList, IonBackButton, IonButtons, IonIcon, IonItemDivider, IonAvatar, IonThumbnail, IonItemOptions, IonItemOption, IonItemSliding, IonInput, IonCheckbox, IonRadio, IonToggle, IonRadioGroup, IonSearchbar, IonSegment, IonSegmentButton, IonDatetime, IonFooter, IonCardContent, IonCardTitle, IonCardHeader, IonCard, IonCol, IonRow, IonGrid, IonChip, IonImg } from '@ionic/angular/standalone';
declare let Swiper: any;
import { CommonModule } from '@angular/common';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';
interface Design {
  "goal": string,
  "style": string,
  "color": string,
  "feature": string,
  "ACC": string,
  "rim": string,
  "period": string,
  "clothing": string,
  "trousers": string,
  "shoe": string,
  "after": string,
  "texture": string,
  "remark":string,
  "image": string,
  "user": string,
  "detail": string,
  "comment": string,
  "avatar":string,
  "username":string


}
@Component({
  selector: 'swiper',
  templateUrl: './swiper.component.html',
  styleUrls: ['./swiper.component.scss'],
  standalone: true,
  imports: [IonContent, IonHeader, IonTitle, IonToolbar, IonButton, IonInput, IonItem, IonList, IonIcon, IonContent, IonHeader, IonTitle, IonToolbar, IonButton, IonLabel, IonLabel, IonList, IonItem, IonBackButton, IonButtons, IonIcon, IonItemDivider, IonAvatar, IonThumbnail, IonItemOptions, IonItemSliding, IonItemOption, IonItemOptions, IonInput, IonCheckbox, IonRadio, IonToggle, IonRadioGroup, IonSearchbar, IonSegment, IonSegmentButton, IonDatetime, IonFooter, IonCardContent, IonCardTitle, IonCardHeader, IonCard, IonCol, IonRow, IonGrid, IonChip, IonImg, SwiperComponent, CommonModule]
})
export class SwiperComponent implements OnInit {
  designTableData: any[] = [
    { name: '小明', age: 25, design: 'T恤设计', color: '蓝色' },
    { name: '小红', age: 30, design: '连衣裙设计', color: '粉色' },
    { name: '小刚', age: 28, design: '夹克设计', color: '黑色' },
    // 你可以继续添加更多的数据
  ];
  constructor() { }

  scrollToElement() {
    const element = document.getElementById('designers');
    if (element) {
      element.scrollIntoView({ behavior: 'smooth', block: 'start' });
    }


  }

  image1: Array<string> = []
  imagineWork: ImagineWork | undefined
  ngOnInit() {
    // let mySwiper = new Swiper('.swiper-container',{
    //   observer:true,//修改swiper自己或子元素时，自动初始化swiper
    //   observeParents:true,//修改swiper的父元素时，自动初始化swiper
    // });

    this.loadDesigne()



    this.imagineWork = new ImagineWork("0Jcfvd45WL");
    this.imagineWork.fetchTask().then(work => {
      this.image1 = this.imagineWork?.images || [];
    })


    var Swiper1 = new Swiper('#swiper1', {
      height:600,
      parallax: true,
      // autoplay: true,
      
      loop: true,
      observer: true,//修改swiper自己或子元素时，自动初始化swiper
      observeParents: true,//修改swiper的父元素时，自动初始化swiper
      // 如果需要分页器
      pagination: {
        el: '.swiper-pagination',
      },

      // 如果需要前进后退按钮
      navigation: {
        nextEl: '.swiper-button-next',
        prevEl: '.swiper-button-prev',
      },

      // 如果需要滚动条
      scrollbar: {
        el: '.swiper-scrollbar',
      },
    })
    var Swiper2 = new Swiper('#swiper2', {
      parallax: true,
      // autoplay: true,
      loop: true,
      observer: true,//修改swiper自己或子元素时，自动初始化swiper
      observeParents: true,//修改swiper的父元素时，自动初始化swiper
      // 如果需要分页器
      pagination: {
        el: '.swiper-pagination',
      },

      // 如果需要前进后退按钮
      navigation: {
        nextEl: '.swiper-button-next',
        prevEl: '.swiper-button-prev',
      },

      // 如果需要滚动条
      scrollbar: {
        el: '.swiper-scrollbar',
      },
      controller: {
        control: Swiper1,
      }
    })
    // var mySwiper = new Swiper ('.swiper-container', {
    //   parallax : true,
    //   autoplay:true,
    //   loop: true,
    //   observer:true,//修改swiper自己或子元素时，自动初始化swiper
    //   observeParents:true,//修改swiper的父元素时，自动初始化swiper
    //   // 如果需要分页器
    //   pagination: {
    //     el: '.swiper-pagination',
    //   },

    //   // 如果需要前进后退按钮
    //   navigation: {
    //     nextEl: '.swiper-button-next',
    //     prevEl: '.swiper-button-prev',
    //   },

    //   // 如果需要滚动条
    //   scrollbar: {
    //     el: '.swiper-scrollbar',
    //   },
    // })



  }
  avatar:string=""
  async getUserByUsername(username: string):Promise<string> {
    try {
        // 等待用户数据的 Promise 解析
        const user = await new CloudUser().getUserByUsername(username);

        // 确保 user 存在并且包含数据
        if (user && user.data) {
            console.log("user.get('avatar'); ",user.get('avatar'));
            let a:string=user.get('avatar')

            return a; // 返回 avatar
        } else {
            return ""; // 如果没有找到 avatar，返回 null
        }
    } catch (error) {
        console.error('Error fetching user data:', error);
        return ""; // 处理错误并返回 null
    }
}

async getUserByUsername2(username: string):Promise<string> {
  try {
      // 等待用户数据的 Promise 解析
      const user = await new CloudUser().getUserByUsername(username);

      // 确保 user 存在并且包含数据
      if (user && user.data) {
          console.log("user.get('avatar'); ",user.get('avatar'));
          let a:string=user.get('realname')

          return a; // 返回 avatar
      } else {
          return ""; // 如果没有找到 avatar，返回 null
      }
  } catch (error) {
      console.error('Error fetching user data:', error);
      return ""; // 处理错误并返回 null
  }
}
  count = 4
  designList:Array<Design> = []
  async loadDesigne() {

   
    

    let query = new CloudQuery("Designs");
    let designList: Array<CloudObject> = await query.find()
    
    let aa = designList.map(item => item.data)
    console.log(aa);
    aa = aa.filter(data => data['comment'] !== undefined && data['comment'] !== '')
    console.log(aa);

    let indices = Array.from({ length: aa.length }, (_, i) => i);

    // 打乱索引数组
    indices.sort(() => Math.random() - 0.5);

    // 从打乱后的索引数组中选取前count个索引，并对应的从原数组中获取元素
    let bb = indices.slice(0, this.count).map(index => aa[index]);
    console.log(bb[0]['image']);

    let cc:Array<Design>=await Promise.all(
      bb.map(async item=>{
        let avatar: string = await this.getUserByUsername(item['user'].objectId);
        let username: string = await this.getUserByUsername2(item['user'].objectId);
  
        let obj= {
          "goal":item['goal'] ,
          "style":item['style'] ,
          "color":item['color'] ,
          "feature":item['feature'] ,
          "ACC":item['ACC'] ,
          "rim":item['rim'] ,
          "period":item['period'] ,
          "clothing":item['clothing'] ,
          "trousers":item['trousers'] ,
          "shoe": item['shoe'],
          "after":item['after'] ,
          "texture":item['texture'] ,
          "remark":item['remark'],
          "image": item['image'],
          "user":item['user'].objectId ,
          "detail":item['detail'] ,
          "comment":item['comment'] ,
          "avatar":avatar,
          "username":username
        
        }
        return obj;
      })
    )
    
    this.designList = cc
    console.log(this.designList[0].detail);
    
    console.log("this.designList::::",this.designList);
    
    

  }
  ngAfterViewInit() {
  }

}
