import { Component, OnInit } from '@angular/core';
import { IonicModule, ToastController } from '@ionic/angular';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { TagInputComponent } from '../tag-input/tag-input.component';
import { addIcons } from 'ionicons';
import { barbellOutline, personOutline, square, alarmOutline, arrowBack } from 'ionicons/icons';
import { DalleOptions, FmodeChatCompletion, ImagineWork, MarkdownPreviewModule } from 'fmode-ng';
import { LoadingController } from '@ionic/angular';
import { AlertController, IonThumbnail, IonBadge, IonButton, IonButtons, IonCard, IonCardContent, IonCardHeader, IonCardSubtitle, IonCardTitle, IonCol, IonContent, IonGrid, IonHeader, IonIcon, IonImg, IonInput, IonItem, IonLabel, IonList, IonRow, IonSegment, IonSegmentButton, IonSelect, IonSelectOption, IonToolbar, IonTitle, IonSpinner, IonTextarea } from '@ionic/angular/standalone';
import { NavController } from '@ionic/angular';
import { Router } from '@angular/router';
import { CloudObject, CloudQuery, CloudUser } from 'src/lib/ncloud';
import { IonBackButton } from '@ionic/angular/standalone';
@Component({
  selector: 'app-test-page',
  templateUrl: './test-page.component.html',
  styleUrls: ['./test-page.component.scss'],
  standalone: true,
  imports: [
    IonTextarea,
    IonSpinner,
    IonTitle,
    IonBackButton,
    MarkdownPreviewModule,
    IonSelectOption,
    IonSelect,
    IonThumbnail,
    IonCardSubtitle,
    IonImg,
    IonCard,
    IonCardTitle,
    IonCardHeader,
    IonCardContent,
    IonButtons,
    IonItem,
    IonList,
    IonIcon,
    FormsModule,
    CommonModule,
    IonHeader,
    IonToolbar,
    IonContent,
    IonSegment,
    IonSegmentButton,
    IonGrid,
    IonRow,
    IonCol,
    IonButton,
    IonLabel,
    IonBadge,
    IonInput,
    TagInputComponent
  ]  // 添加 CommonModule
})
export class TestPageComponent implements OnInit {
  selectedTags: string[] | undefined;
  gender: any;
  ngOnInit(): void {
  }
  height: number | null = null;   // 身高
  weight: number | null = null;    // 体重
  xiong: number | null = null;     // 胸围
  yao: number | null = null;       // 腰围
  tun: number | null = null;       // 臀围
  goalDescription: string = '';     // 目标描述
  selectedIndex: number | null = null; // 选中的颜色索引
  colors: string[] = ['red', 'green', 'blue', 'yellow', 'orange'];
  colorNames: string[] = ['红色', '绿色', '蓝色', '黄色', '橙色'];

  onHeightChange(event: any) {
    this.height = event.target.value;
  }

  onWeightChange(event: any) {
    this.weight = event.target.value;
  }


  onXiongChange(event: any) {
    this.xiong = event.target.value;
  }

  onYaoChange(event: any) {
    this.yao = event.target.value;
  }

  onTunChange(event: any) {
    this.tun = event.target.value;
  }

  onGoalDescriptionChange(event: any) {
    this.goalDescription = event.target.value;
  }

  selectDot(index: number) {
    this.selectedIndex = index;
    console.log('Selected color index:', index);
    console.log('Selected color:', this.colors[index]);
  }

  getAllInputs() {
    const inputs = {
      height: this.height,
      weight: this.weight,
      xiong: this.xiong,
      yao: this.yao,
      tun: this.tun,
      goalDescription: this.goalDescription,
      selectedColor: this.selectedIndex !== null ? this.colors[this.selectedIndex] : null, // 如果没有选择，则为 null
    };
    console.log('All inputs:', inputs);
    return inputs;
  }
  onTagsChanged(tags: string[]) {
    this.selectedTags = tags;
    console.log('当前标签:', this.selectedTags);
  }
  onGenderChange(ev: any) {
    this.gender = ev.target.value;

  }

  gpt: string = ""
  imagineWork: ImagineWork | undefined
  images: Array<string> = []
  isComplete:boolean=false
  test(){
    console.log(this.selectedTags);
    
  }
  createImg() {
    this.imagineWork = new ImagineWork();
    let options: DalleOptions = { prompt: this.gpt }
    this.imagineWork.draw(options).subscribe(async work => {
      console.log("imagineWork", work?.toJSON())
      console.log("images", work?.get("images"))
      if (work?.get("images")?.length) {
        this.images = work?.get("images");
      }
    })
  }

  create() {
      let promt = `你作为一名专业的服装设计师，风格是:${this.selectedTags},描述是${this.goalDescription},
    身高是${this.height},体重是${this.height},性别是${this.gender},胸围是${this.xiong},腰围是${this.yao},臀围是${this.tun}
    爱好颜色是${this.selectedIndex !== null ? this.colors[this.selectedIndex] : null},请你联想并补充服装细节
`

    let completion = new FmodeChatCompletion([
        { role: "system", content: "" },
        { role: "user", content: promt }
      ])
    completion.sendCompletion().subscribe((message: any) => {

        // 打印消息体
        console.log(message.content)


        // 赋值消息内容给组件内属性
        this.gpt = message.content
        if (message?.complete) {
          this.isComplete=true
          this.createImg()
        }
      }
      )
    }
}
