import { Input, OnInit } from '@angular/core';
import { Component } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { IonHeader, IonToolbar, IonTitle, IonContent, IonCard, IonCardContent, IonButton, IonCardHeader, IonCardTitle, IonCardSubtitle, ModalController, IonInput, IonItem, IonSegment, IonSegmentButton, IonLabel, IonTextarea } from '@ionic/angular/standalone';
import { CloudUser } from 'src/lib/ncloud';
interface CommentObject {
  title: string;
  title2: string;
}

@Component({
  selector: 'app-modal-comment-post',
  templateUrl: './modal-comment-post.component.html',
  styleUrls: ['./modal-comment-post.component.scss'],
  standalone: true,
  imports: [IonHeader, IonToolbar, IonTitle, IonContent, 
    IonCard,IonCardContent,IonButton,IonCardHeader,IonCardTitle,IonCardSubtitle,
    IonInput,IonItem,
    IonSegment,IonSegmentButton,IonLabel,IonTextarea,FormsModule
  ],
})
export class ModalCommentPostComponent  implements OnInit {

  currentUser:CloudUser|undefined
  object2:CommentObject={ title: '', title2: '' };

  constructor(private modalCtrl:ModalController) { 
    
  }

  ngOnInit() {}
  text=""
  async save(){
    
    this.modalCtrl.dismiss(this.text,"confirm")
  }
  cancel(){
    this.modalCtrl.dismiss(null,"cancel")

  }
}

export async function openCommentPostModal(modalCtrl:ModalController,object:object):Promise<string|null>{
  
  const modal = await modalCtrl.create({
    component: ModalCommentPostComponent,
    breakpoints:[0.7,1.0],
    initialBreakpoint:0.7,
    componentProps:{object2:object}
  });
  modal.present();

  const { data, role } = await modal.onWillDismiss();

  if (role === 'confirm') {
    return data;
  }
  return null
}